- entityDefinitions:
  - IDI_Task_Element_View: '{64e9c8f6-c3d7-4915-98c8-83b91c211a8d}'
  - IDI_Task_Element_Edit:    '{639b6404-4cb4-4365-9600-4e703e1f1675}'
  - IDE_Element_View: '{3abffca7-b904-4988-9583-cf7f4fc4146e}'
  - IDE_Element_Edit: '{f39280f4-a62a-4fb3-9f58-3a4abe57cee9}'
  - IDI_TaskCategory_Element: '{7ac1d803-7007-4b3d-b06e-886d62f758c9}'
  - IDE_Element_Contents: '{bcdfc114-ca61-4918-8630-a492293b5f9d}'
  - IDE_Element_View_Toolbar: '{ad0b929c-d24f-42e9-8548-cca0d30ee760}'
  - IDE_Element_Common: '{beb75322-b61e-444e-b0ab-8ac7a5103953}'
  
  - IDMB_Element__get__Returned_by_BEM__Task_Related_Instance: '{ea65f363-deb4-4a94-ae49-ba11eeef08dc}'

- library: '&IDL_MochaBaseSystem;'
  instances:
  - taskCategory: '&IDI_TaskCategory_Element;'
    name: 'Element'

    
  # - sequenceTask: '&IDI_Task_Element_View;'
  #   name: 'View Element'
  #   schedulable: no
  #   longRunning: no
  #   suppressRIHints: no
  #   stepName: View Element
  #   showSpreadsheetButtonOnSelection: no
  #   taskCategory: '&IDI_TaskCategory_Element;'
  #   initiatingElement: '&IDE_ElementStart;'
  
  # - element: '&IDE_ElementStart;'
  #   name: 'Element Start'
  #   elementContents:
  #   - globalIdentifier: '{2b534e53-b0ef-429d-b9a4-4eba9e36a455}'
  #     defaultDataType: '&IDC_Element;'
  #     order: a
  #   - globalIdentifier: '{450794b8-c01d-4545-b29c-3f3adf0ca391}'
  #     defaultDataType: '&IDA_Name;'

  - sequenceTask: '&IDI_Task_Element_View;'
    name: 'View Element'
    schedulable: no
    longRunning: no
    suppressRIHints: no
    stepName: View Element
    showSpreadsheetButtonOnSelection: no
    taskCategory: '&IDI_TaskCategory_Element;'
    initiatingElement: '&IDE_Element_View;'

  - sequenceTask: '&IDI_Task_Element_Edit;'
    name: 'Edit Element'
    schedulable: no
    longRunning: no
    suppressRIHints: no
    stepName: Edit Element
    showSpreadsheetButtonOnSelection: no
    taskCategory: '&IDI_TaskCategory_Element;'
    initiatingElement: '&IDE_Element_Edit;'

  - buildElementMethod: '{266842bb-e4cc-43fe-9334-1d3571e4df14}'
    hasBemProcess: '{86bba17c-866f-41bc-b397-ad33da90f452}'

  - bemProcess: '{86bba17c-866f-41bc-b397-ad33da90f452}'
    name: 'build element contents'
    loopExecutableReturningInstanceSet: '&IDMB_Element__get__Element_Contents;'

  - returnInstanceSetMethodBinding: '&IDMB_Element__get__Returned_by_BEM__Task_Related_Instance;'
    executesMethod: '&IDM_Element__get__Returned_by_BEM;'
    parameterAssignments:
    - assignsToParameter: '&IDC_Element;'
      assignsFromWorkData: '&IDI_WorkSet_TaskRelatedInstance;'

  - element: '&IDE_Element_View_Toolbar;'
    name: 'view element buttons'
    elementContents:
    - globalIdentifier: '{04ce9724-fa4f-4200-a7e6-c71c871004b0}'
      layout:
      - type: '&IDC_ButtonLayout;'
        executesTask: '&IDI_Task_Element_Edit;'
        relatedInstance: '&IDI_WorkSet_TaskRelatedInstance;'
      label: 'Edit'
    - globalIdentifier: '{b955d049-faf0-4a1b-a345-ee41b377dc78}'
      layout:
      - type: '&IDC_ButtonLayout;'
        # executesTask: '&IDI_Task_ViewBuildElementMethod;'
        executesTask: '&IDI_Task_Element_Edit;'
        relatedInstance: '&IDMB_Element__get__Returned_by_BEM__Task_Related_Instance;'
      label: 'View BEM'
      value:
      - taskId: '&IDI_Task_Element_Edit;'
      - parameterAssignments:
        - globalIdentifier: '{d5934e6a-85f1-41fc-bab0-91bce09771da}'
          assignsToParm: '&IDC_Class;'
          assignsFromWorkData: '&IDC_Class;'
    - globalIdentifier: '{7ae5d892-9d46-4962-b763-8f8071c8cc18}'
      layout:
      - type: '&IDC_ButtonLayout;'
        # executesTask: '&IDI_Task_EditBuildElementMethod;'
        executesTask: '&IDI_Task_Element_Edit;'
        relatedInstance: '&IDMB_Element__get__Returned_by_BEM;'
      label: 'Edit BEM'
      value:
      - taskId: '&IDI_Task_Element_Edit;'
      - parameterAssignments:
        - globalIdentifier: '{25e4769f-7e66-4f24-8eeb-d1f366f4d034}'
          assignsToParm: '&IDC_Class;'
          assignsFromWorkData: '&IDC_Class;'
    - globalIdentifier: '{3e499d91-d000-4d10-9042-5ea8c9a404e7}'
      layout: '&IDI_ButtonLayout_DefaultButtonGroup;'
      label: 'Create Layout'
      value:
      - taskId: '&IDI_Task_Element_Edit;'
      - parameterAssignments:
        - globalIdentifier: '{ec645f96-cf05-43df-a7ad-0ecae3422d16}'
          assignsToParm: '&IDC_Class;'
          assignsFromWorkData: '&IDC_Class;'
    - globalIdentifier: '{56d3a886-5a21-4f33-a12d-64660bac3f74}'
      layout: '&IDI_ButtonLayout_DefaultButtonGroup;'
      label: 'Refactor'
      value:
      - taskId: '&IDI_Task_Element_Edit;'
      - parameterAssignments:
        - globalIdentifier: '{62c33423-df32-4d62-a85b-18fed47a4b31}'
          assignsToParm: '&IDC_Class;'
          assignsFromWorkData: '&IDC_Class;'

  - element: '&IDE_Element_View;'
    name: 'view element'
    elementContents:
    - globalIdentifier: '{2b534e53-b0ef-429d-b9a4-4eba9e36a455}'
      defaultDataType: '&IDC_Element;'
      order: a
      displayOptions:
      - instance: '&IDI_DisplayOption_NotEnterable;'
      - instance: '&IDI_DisplayOption_DoNotShow;'
    - globalIdentifier: '{99cf85da-6d7f-436e-af21-33647d3d2e07}'
      defaultDataType: '&IDE_Element_View_Toolbar;'
      order: b
      displayOptions:
      - instance: '&IDI_DisplayOption_Singular;'
    - globalIdentifier: '{ebc2cf46-6abf-4b23-a85c-2d4a950f0aef}'
      defaultDataType: '&IDE_Element_Common;'
      order: c
      displayOptions:
      - instance: '&IDI_DisplayOption_NotEnterable;'
      - instance: '&IDI_DisplayOption_Singular;'
      - instance: '&IDI_DisplayOption_ShowSubelementsVertically;'
    - globalIdentifier: '{1da14355-53b1-4b2d-95a9-2cdc0bfb7b20}'
      defaultDataType: '&IDE_Element_Contents;'
      order: d
      builtFromBEMProcess: '{86bba17c-866f-41bc-b397-ad33da90f452}'
      displayOptions:
      - instance: '&IDI_DisplayOption_RowsNotEditable;'

  - element: '&IDE_Element_Common;'
    name: 'element subedits'
    elementContents:
    - globalIdentifier: '{3dd3c7f6-9da6-48bc-8fe5-a6d03dcd1d9e}'
      defaultDataType: '&IDA_Name;'
      order: a

  - element: '&IDE_Element_Edit;'
    name: 'edit element'
    elementContents:
    - globalIdentifier: '{6601645e-8b99-41c1-a8a6-910522322ae7}'
      defaultDataType: '&IDC_Element;'
      order: a
      displayOptions:
      - instance: '&IDI_DisplayOption_DoNotShow;'
    - globalIdentifier: '{2300fe82-ee5b-4d43-9220-ae369afe636d}'
      defaultDataType: '&IDE_Element_Common;'
      order: b
      displayOptions:
      - instance: '&IDI_DisplayOption_Singular;'
      - instance: '&IDI_DisplayOption_ShowSubelementsVertically;'
    - globalIdentifier: '{7dfe8478-d706-414f-9bef-ab4bb8bdf8b8}'
      defaultDataType: '&IDE_Element_Contents;'
      order: c
      builtFromBEMProcess: '{86bba17c-866f-41bc-b397-ad33da90f452}'

  - element: '&IDE_Element_Contents;'
    name: 'Element Contents'
    elementContents:
    - globalIdentifier: '{80b21b10-8198-47e5-8e7f-255774d5b1bb}'
      defaultDataType: '&IDC_ElementContent;'
      order: a
      displayOptions:
      - instance: '&IDI_DisplayOption_NotEnterable;'
    - globalIdentifier: '{4a72c7a3-0851-4eaf-9757-5b75341d1b35}'
      defaultDataType: '&IDA_Order;'
      order: b
    - globalIdentifier: '{d48e7018-e431-47d0-b8af-23ddd3f6f5e4}'
      defaultDataType: '&IDR_Element_Content__has__Instance;'
      order: c
      label: 'Default Data Type'
      displayOptions:
      - instance: '&IDI_DisplayOption_NotEnterable;'
    - globalIdentifier: '{6f6aedb8-60dd-487a-b9be-435d4ef01f3e}'
      defaultDataType: '&IDR_Element_Content__has__Instance;'
      order: d
      label: 'Data Type Override'
    - globalIdentifier: '{1c390eef-7190-4cfa-a2d3-aaeb9058922d}'
      defaultDataType: '&IDR_Element_Content__built_from__BEM_Process;'
      order: e
      label: 'BEM Process'
      displayOptions:
      - instance: '&IDI_DisplayOption_NotEnterable;'
    # - globalIdentifier: '{b59e0a3a-115c-4678-b284-4f45710a045a}'
    #   defaultDataType: '&IDA_AutomationID;'
    #   order: f
    - globalIdentifier: '{1bee5873-97ef-43ce-a8c1-f51310bd4452}'
      defaultDataType: '&IDA_Label;'
      order: g
      label: 'Default Label'
      displayOptions:
      - instance: '&IDI_DisplayOption_NotEnterable;'
    - globalIdentifier: '{593120df-164e-4883-84ba-f2a5294241b0}'
      defaultDataType: '&IDA_LabelOverride;'
      order: h
      label: 'Label Override'
    - globalIdentifier: '{c47b06d5-354a-4087-8b67-883a7b27bb60}'
      defaultDataType: '&IDR_Element_Content__has__Element_Content_Display_Option;'
      order: i
      label: 'Uses Display Options'
    # - globalIdentifier: '{f5a02c4f-fc90-40a0-a814-d1a8de6814e2}'
    #   defaultDataType: 'Has Restrictions'
    #   order: j